// Wenn eine Datei ausgewählt wurde, dann sende die Datei an den Server
$(document).ready(function() {
    $("#input_spreadsheet").change(function() {
        formData = new FormData($("#form_spreadsheet_upload")[0]);
        $.ajax({
            type: "POST",
            url: "api/upload",
            data: formData,
            processData: false,
            contentType: false,
            success: function (response) {
                // Mache einen Integer aus "response"
                response = parseInt(response);
                // Wenn "response" kleiner als 0 ist, dann ist ein Fehler aufgetreten
                if (response < 0) {
                    // Zeige Fehlermeldung an
                    $("#text_error").text("Bitte wähle eine Excel-Datei aus. Deine Datei ist entweder leer oder hat ein falsches Format.");
                    // Zeige Fehler-Modal an
                    $("#modal_error").modal("show");
                } else if (response == 0) {
                    // Zeige Fehlermeldung an
                    $("#text_error").text("Die Excel-Datei enthält keine Daten. Bitte füge Daten hinzu und versuche es erneut.");
                    // Zeige Fehler-Modal an
                    $("#modal_error").modal("show");
                } else if (response > 50) {
                    // Zeige Fehlermeldung an
                    $("#text_error").text("Die Excel-Datei enthält zu viele Daten. Bitte lösche einige Daten und versuche es erneut.");
                    // Zeige Fehler-Modal an
                    $("#modal_error").modal("show");
                } else {
                    // Zeige Erfolgsmeldung an
                    $("#text_uploaded_count").text(response);
                    // Zeige Erfolg-Modal an
                    $("#modal_uploaded").modal("show");
                }
            }
        });
    });
});

// Wenn der Button "btn_create_letter" geklickt wurde, dann sende eine Anfrage an den Server
$("#btn_create_letter").click(function() {

    // Schließe das Modal "modal_uploaded"
    $("#modal_uploaded").modal("hide");

    // Zeige Progress-Modal an
    $("#modal_progress").modal("show");

    $.ajax({
        type: "POST",
        url: "api/insert-angebot",
        success: function (response) {
            // Mache einen Integer aus "response"
            response = parseInt(response);
            // Wenn "response" kleiner als 0 ist, dann ist ein Fehler aufgetreten
            if (response < 0) {
                // Zeige Fehlermeldung an
                $("#progress_modal").modal("hide");
                $("#text_error").text("Es ist ein Fehler aufgetreten. Bitte versuche es erneut.");
                // Zeige Fehler-Modal an
                $("#modal_error").modal("show");
            } else {
                // Warte 2 Sekunden
                setTimeout(function() {
                    // Aktualisiere Progress-Text
                    $("#text_progress").text("Bestellungen werden konvertiert...");
                    // Aktualisiere Progress-Bar
                    $("#progress_bar").css("width", "30%");
                    // Führe Funktion "insert_bestellungen" aus
                    insert_bestellungen();
                }, 500);
            }
        }
    });
});

function insert_bestellungen () {
    $.ajax({
        type: "POST",
        url: "api/insert-bestellungen",
        success: function (response) {
            // Mache einen Integer aus "response"
            response = parseInt(response);
            // Wenn "response" kleiner als 0 ist, dann ist ein Fehler aufgetreten
            if (response < 0) {
                // Zeige Fehlermeldung an
                $("#progress_modal").modal("hide");
                $("#text_error").text("Es ist ein Fehler aufgetreten. Bitte versuche es erneut.");
                // Zeige Fehler-Modal an
                $("#modal_error").modal("show");
            } else {
                // Warte 2 Sekunden
                setTimeout(function() {
                    // Aktualisiere Progress-Text
                    $("#text_progress").text("Briefe werden erstellt...");
                    // Aktualisiere Progress-Bar
                    $("#progress_bar").css("width", "50%");
                    // Führe Funktion "generate_letter" aus
                    generate_letter();
                }, 500);
            }
        }
    });
}

var filename = "";

function generate_letter () {
    $.ajax({
        type: "POST",
        url: "api/generate-letter",
        success: function (response) {
            // Überprüfe ob "response" mit "bestellungen-" beginnt
            if (response.startsWith("bestellungen-")) {
                // Setze "filename" auf "response"
                filename = response;
                // Warte 2 Sekunden
                setTimeout(function () {
                    // Aktualisiere Progress-Text
                    $("#text_progress").text("Download wird vorbereitet...");
                    // Aktualisiere Progress-Bar
                    $("#progress_bar").css("width", "80%");
                    // Führe Funktion "remove_artifacts" aus
                    remove_artifacts();
                }, 500);
            } else {
                // Zeige Fehlermeldung an
                $("#progress_modal").modal("hide");
                $("#text_error").text("Es ist ein Fehler aufgetreten. Bitte versuche es erneut. (Fehler: " + response + ")");
                // Zeige Fehler-Modal an
                $("#modal_error").modal("show");
            }
        }
    });
}

function remove_artifacts () {
    $.ajax({
        type: "POST",
        url: "api/remove-artifacts",
        success: function (response) {
            // Mache einen Integer aus "response"
            response = parseInt(response);
            // Wenn "response" kleiner als 0 ist, dann ist ein Fehler aufgetreten
            if (response < 0) {
                // Zeige Fehlermeldung an
                $("#progress_modal").modal("hide");
                $("#text_error").text("Es ist ein Fehler aufgetreten. Bitte versuche es erneut.");
                // Zeige Fehler-Modal an
                $("#modal_error").modal("show");
            } else {
                // Warte 2 Sekunden
                setTimeout(function() {
                    // Aktualisiere Progress-Text
                    $("#text_progress").text("Einen Moment bitte...");
                    // Aktualisiere Progress-Bar
                    $("#progress_bar").css("width", "95%");
                    // Schließe Progress-Modal
                    $("#modal_progress").modal("hide");
                    // Setze Download-Link
                    $("#btn_download").attr("href", "api/download-letter?filename=" + filename);
                    // Zeige Erfolg-Modal an
                    $("#modal_success").modal("show");
                }, 500);
            }
        }
    });
}

// Wenn der Button "btn_download" geklickt wurde, dann verstecke ihn 1 Sekunde später
$("#btn_download").click(function() {
    setTimeout(function() {
        $("#btn_download").hide();
    }, 20);
});