<!doctype html>
<html lang="de" data-bs-theme="dark">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Essensbestellung</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>
</head>

<body>
    <div class="container mt-5">
        <h1>
            Essensbestellung
        </h1>

        <form id="form_spreadsheet_upload" enctype="multipart/form-data">
            <div class="mt-5">
                <label for="input_spreadsheet" class="form-label">Tabelle</label>
                <input class="form-control form-control-lg" id="input_spreadsheet" type="file" name="input_spreadsheet">
            </div>
        </form>


    </div>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN" crossorigin="anonymous"></script>

    <!-- ################################# -->
    <!-- ################################# -->
    <!-- Modals -->
    <!-- ################################# -->
    <!-- ################################# -->

    <!-- Modal -> error -->
    <div class="modal fade" id="modal_error" tabindex="-1" aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog mx-0 mx-sm-auto modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header bg-danger text-center">
                    <h5 class="modal-title text-white">Fehler</h5>
                </div>
                <div class="modal-body">
                    <p class="text-center" id="text_error">Die hochgeladene Datei ist keine Excel-Datei.</p>
                </div>
                <div class="modal-footer">
                    <a href="?refresh_token=<?= uniqid(); ?>" class="btn btn-danger">
                        Okay
                    </a>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal -> uploaded -->
    <div class="modal fade" id="modal_uploaded" tabindex="-1" aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog mx-0 mx-sm-auto modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header bg-primary text-center">
                    <h5 class="modal-title text-white">Möchtest du fortfahren?</h5>
                </div>
                <div class="modal-body">
                    <p class="text-center">
                        Es wurden <b id="text_uploaded_count"></b> Bestellungen gefunden.
                        Möchtest du den Reihenbrief für diese Bestellungen erstellen?
                    </p>
                </div>
                <div class="modal-footer">
                    <a href="?refresh_token=<?= uniqid(); ?>" class="btn btn-outline-secondary">
                        ❌
                        Abbrechen
                    </a>
                    <button type="button" class="btn btn-primary" id="btn_create_letter">
                        Reihenbrief erstellen
                        ➡️
                    </button>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal -> progress -->
    <div class="modal fade" id="modal_progress" tabindex="-1" aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog mx-0 mx-sm-auto modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <p class="text-center" id="text_progress">
                        Essensangebot wird konvertiert...
                    </p>
                    <div class="progress" role="progressbar" aria-valuenow="75" aria-valuemin="0" aria-valuemax="100">
                        <div class="progress-bar progress-bar-striped progress-bar-animated" style="width: 10%" id="progress_bar"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal -> success -->
    <div class="modal fade" id="modal_success" tabindex="-1" aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog mx-0 mx-sm-auto modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header bg-success text-center">
                    <h5 class="modal-title text-white">
                        ✅
                        Download bereit
                    </h5>
                </div>
                <div class="modal-body">
                    <p class="text-center">
                        Dein Reihenbrief wurde erfolgreich erstellt.
                        Du kannst ihn nun herunterladen.
                        <b>Nach einmaligem Download wird er automatisch gelöscht.</b>
                    </p>
                </div>
                <div class="modal-footer">
                    <a href="?refresh_token=<?= uniqid(); ?>" class="btn btn-outline-secondary">
                        🔄️
                        Neu starten
                    </a>
                    <a class="btn btn-success" id="btn_download" href="">
                        💾
                        Download
                    </a>
                </div>
            </div>
        </div>
    </div>

    <script src="app.js" defer></script>
</body>

</html>